<template>
  <div>
    <div class="text-lg font-bold mb-5">Your visit summary</div>
    <div class="flex flex-col pt-5 px-4 bg-white rounded-lg mb-3">
      <div class="pb-5 grid grid-cols-2">
        <div>
          <div class="mb-1 text-base">{{ boughtProduct.name }}</div>
          <div class="text-xs text-grey-dark mb-2">
            <p>{{ boughtProduct.supplyDuration }}</p>
            <p>{{ boughtProduct.shipping }}</p>
          </div>
          <div
            v-if="boughtProduct.newPrice"
            class="text-xs text-red"
          >
            You saved ${{ boughtProduct.oldPrice - boughtProduct.newPrice }}
          </div>
        </div>
        <div class="text-right flex flex-col justify-center text-base justify-self-end">
          <template v-if="boughtProduct.price">
            <p>${{ boughtProduct.price }}</p>
          </template>
          <template v-else>
            <p class="text-grey-dark line-through">${{ boughtProduct.oldPrice }}</p>
            <p>${{ boughtProduct.newPrice }}</p>
          </template>
        </div>
      </div>
      <div
        class="flex justify-between items-center border-t border-grey-darker pt-5 pb-4"
        v-for="item in orderedItems"
        :key="item.id"
      >
        <div>{{ item.title }}</div>
        <div class="text-base" v-if="item.newPrice">
          <p class="text-grey-dark line-through">${{ item.oldPrice }}</p>
          <p>${{ item.newPrice }}</p>
        </div>
        <div v-else class="text-base">${{ item.price }}</div>
      </div>
    </div>
    <p class="text-xs mb-8">You won’t be charged for or shipped this prescription product unless a doctor prescribes it to you.</p>
    <div class="space-y-6 mb-12">
      <section class="flex items-center">
        <div class="icon-doctor bg-no-repeat bg-contain bg-center mr-2"/>
        <div class="text-base text-black-dark">FREE virtual doctor consultation</div>
      </section>
      <section class="flex items-center">
        <div class="icon-shipping bg-no-repeat bg-contain bg-center mr-2"/>
        <div class="text-base text-black-dark">FREE 2-day expedited shipping</div>
      </section>
    </div>
    <p class="text-xs uppercase mb-5">Customers also bought</p>
    <div class="space-y-3 mb-8">
      <div
        class="rounded-lg bg-white flex space-x-5 p-5"
        v-for="item in itemsToOrder"
        :key="item.title"
      >
        <img class="object-contain" :src="item.img" alt="" width="100px">
        <div class="flex-auto">
          <div class="mb-1 text-base">{{ item.title }}</div>
          <p class="mb-3 text-xs text-grey-dark">{{ item.description }}</p>
          <section class="flex items-center justify-between">
            <div
              @click="orderItem(item.id)"
              class="flex items-center py-3 px-5 rounded-md cursor-pointer border border-red font-bold text-sm"
            >
              <div v-if="isItemBought(item.id)" class="checkmark"/>
              <div>{{ isItemBought(item.id) ? 'Added' : 'Add' }}</div>
            </div>
            <div v-if="isItemBought(item.id)">
              <span @click="removeItem(item.id)" class="text-xs underline text-grey-dark cursor-pointer">Remove</span>
            </div>
            <div v-else>
              <span class="text-xs color-grey-dark line-through">${{ item.oldPrice }}</span> <span class="text-base">${{ item.newPrice }}</span>
            </div>
          </section>
        </div>
      </div>
    </div>
    <CommonBtn
      text="Continue to Shipping"
      @click="$emit('nextStage')"
    />
  </div>
</template>

<script>
import {answersMixin, productMixin} from "@/utils/mixins";
import {constants} from "@/constants";
import CommonBtn from "@/components/common/CommonBtn";

export default {
  components: {CommonBtn},
  mixins: [answersMixin, productMixin],
  name: "VisitSummarySummary",
  data() {
    return {
      itemsToOrder: [
        {id: 0, img: require("@/assets/img/misc/performance-wipes.png"), title: 'Performance Wipes', description: 'Last longer during sex with these fast acting wipes', oldPrice: 26.95, newPrice: 14.95},
        {id: 1, img: require("@/assets/img/misc/prebiotic.png"), title: 'Beta Glucan Prebiotic', description: 'Boost your immune system and overall health with these daily capsules', oldPrice: 42.95, newPrice: 24.95},
      ]
    }
  },
  methods: {
    orderItem(itemId) {
      const items = this.orderedItems
      if (!items.map(item => item.id).includes(itemId)) {
        items.push(this.itemsToOrder.find(item => item.id === itemId))
        this.setAnswer(this.answersKeys.VISIT_SUMMARY, items, 'ordered_items')
      }

    },
    removeItem(itemId) {
      const items = this.orderedItems
      if (items.map(item => item.id).includes(itemId)) {
        const idx = items.findIndex(item => item.id === itemId)
        items.splice(idx, 1)
        this.setAnswer(this.answersKeys.VISIT_SUMMARY, items, 'ordered_items')
      }
    },
    isItemBought(itemId) {
      return this.orderedItemsIds.includes(itemId)
    }
  },
  computed: {
    orderedItemsIds() {
      return this.orderedItems.map(item => item.id) || []
    },
  }
}
</script>

<style scoped>
.icon-doctor {
  width: 50px;
  height: 30px;
  background-image: url(~@/assets/img/icons/doctor.png);
}

.icon-shipping {
  width: 50px;
  height: 30px;
  background-image: url(~@/assets/img/icons/free-shipping.png);
}

.checkmark {
  @apply bg-red mr-1;
  content: '';
  width: 10px;
  height: 10px;
  mask: url(~@/assets/img/icons/tick.svg) no-repeat center / contain;
}

</style>
